/*				inilin				*/

void inilin()
{
/*
	this subroutine initializes the com port defined by
	global cmport (0=com1, 1=com2).
	the initialization parameters are set using param
*/
#include <stdio.h>
#include <dos.h>
#include <conio.h>

char param;
extern int cmport; /* which comport to use ? */
extern int hs;     /* which speed to use ?   */
extern int lpadr;   /* address of line printer -- determined here */
extern int lpt;     /* pulse line printer? 1=yes, 0= no */
extern char number[30];   /* which number to dial, first char = mode*/
extern union REGS inregs, outregs;

int j;
unsigned char stat;
/*
	300 baud     no  parity    1 stop bit     8 bits
         0  1  0        0  0           0           1  1
	1200 baud    no parity     1 stop bit     8 bits
	 1  0  0        0  0           0           1  1
	9600 baud    no parity     1 stop bit     8 bits
	 1  1  1        0  0           0           1  1
*/
	if(hs == 1)param='\x83';
	else       param='\x43';
/*
	_AL=param;
	_AH=0;
	_DX=cmport;
	geninterrupt(0x14);
*/
	inregs.h.al = param;
	inregs.h.ah = 0;
	inregs.x.dx = cmport;
	int86(0x14,&inregs,&outregs);
	stat=outregs.h.al;            /* get modem status */
/*
	if this is automatic dialing using either manual or pulse mode
	then be sure that the modem is ready to go.  check CTS and DSR
*/
	if( (number[3] == 't') || (number[3] == 'T') ||
	    (number[3] == 'p') || (number[3] == 'P') )
	{
	if( (stat & 0x10) == 0)
	   {
	   printf("\nCannot dial because modem does not ");
	   printf("show clear to send (CTS).");
	   exit();
	   }
	if( (stat & 0x20) == 0)
	   {
	   printf("\nCannot dial because modem does not ");
	   printf("show data set ready (DSR).");
	   exit();
	   }
	}
/*
	now set line printer address if lpt is set to pulse it. if
	lpt is zero so that pulsing is disabled, then return now.
	first try to set address 37a and read it back. then try
	address 3be and read it back.
*/
	if(lpt == 0) return;
	outp(0x37a,1);
	for(j=0; j<200; j++);   /*wait a bit*/
	if( (inp(0x37a) & 0x1f) == 1)
	{
	lpadr=0x37a;
	outp(0x37a,0);
	return;
	}
	for(j=0; j<200; j++);
	outp(0x3be,1);
	for(j=0; j<200; j++);
	if( (inp(0x3be) & 0x1f) == 1)
	{
	lpadr=0x3be;
	outp(0x3be,0);
	return;
	}
	printf("\n printer-port does not respond to pulse.");
	printf("\n pulsing selection disabled.");
	lpt=0;
}
